'' This object provides direct access display editing for a VGA display using vga_Driver.spin
'' It has no global variables, so it can be referenced from multiple cogs without extra storage
'' being used.  The display routines all require a starting cursor position so that's not changed.

CON cols     = 80                      ' *** DEBUG ***
    rows     = 40                      ' *** DEBUG ***
    screen   = $8000 - cols * rows     ' *** DEBUG ***

PUB debugOut(x,y,c)                    ' *** DEBUG ***
   byte[screen+y*cols+x] := c

PUB debugStr(x,y,s)                    ' *** DEBUG ***
   repeat while byte[s]
      debugOut(x++,y,byte[s++])

PUB debugDec(x,y,value) | i            ' *** DEBUG ***
  if value < 0
    -value
    debugOut(x++,y,"-")
  i := 1_000_000_000
  repeat 10
    if value => i
      debugOut(x++,y,value / i + "0")
      value //= i
      result~~
    elseif result or i == 1
      debugOut(x,y,"0")
    i /= 10

PUB debugHex(x,y,value,digits)         ' *** DEBUG ***
  value <<= (8 - digits) << 2
  repeat digits
    debugOut(x++,y,lookupz((value <-= 4) & $F : "0".."9", "A".."F"))

